-- Haskell data types for the abstract syntax.
-- Generated by the BNF converter.

{-# LANGUAGE GeneralizedNewtypeDeriving #-}

-- | The abstract syntax of language CCS.

module AbsCCS where

import Prelude (String)
import qualified Prelude as C (Eq, Ord, Show, Read)
import qualified Data.String

data Program = TopLevel [Statement]
  deriving (C.Eq, C.Ord, C.Show, C.Read)

data Statement
    = SetDeclaration Identifier [Label] | Assignment Identifier Process
  deriving (C.Eq, C.Ord, C.Show, C.Read)

data Process
    = Summation Process Process
    | Composition Process Process
    | Prefix Action Process
    | RestrictEnum Process [Label]
    | RestrictIdent Process Identifier
    | Rename Process [Relabel]
    | Null
    | Named Identifier
  deriving (C.Eq, C.Ord, C.Show, C.Read)

data Relabel = ToFrom Label Label
  deriving (C.Eq, C.Ord, C.Show, C.Read)

data Action = Output Label | Input Label
  deriving (C.Eq, C.Ord, C.Show, C.Read)

newtype Identifier = Identifier String
  deriving (C.Eq, C.Ord, C.Show, C.Read, Data.String.IsString)

newtype Label = Label String
  deriving (C.Eq, C.Ord, C.Show, C.Read, Data.String.IsString)

